
{*** POVSHELL 3.0 - main program
     last modified: 18.Oct.1994, AP ***}


{$A+,B-,D-,E+,F-,G+,I-,L-,N-,O-,R-,S-,V-,X+}
{$M 8192,8192,655360}

program PoVShell;

uses PovGlob, Crt, Dos, Objects, Drivers, Memory, Views, Menus, Dialogs,
 StdDlg1, MsgBox1, App, Buffers, PovEdit, PovDialg, Utils,
 HelpFile, PovSHelp, ColorSel, TPLList, SysInfo, OverLay;

{$O HelpFile}
{$O ColorSel}
{$O StdDlg1}
{$O MsgBox1}
{$O Buffers}
{$O PovEdit}
{$O PovDialg}
{$O Utils}
{$O TPLList}

const
  HeapSize: word = 32 * (1024 div 16);

{$I commands.inc}

type
  PEditorApp = ^TEditorApp;
  TEditorApp = object(TApplication)
    constructor Init;
    destructor Done; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure GetEvent(var Event: TEvent); virtual;
    function GetPalette: PPalette; virtual;
    procedure InitMenuBar; virtual;
    procedure InitStatusLine; virtual;
    procedure OutOfMemory; virtual;
    procedure InitScreen; virtual;
  end;

var
  ClipWindow: PEditWindow;
  PoVShellApp: TEditorApp;

function ExecDialog(P: PDialog; Data: Pointer): Word;
var
  Result: Word;
begin
  Result := cmCancel;
  P := PDialog(Application^.ValidView(P));
  if P <> nil then
  begin
    if Data <> nil then P^.SetData(Data^);
    Result := DeskTop^.ExecView(P);
    if (Result <> cmCancel) and (Data <> nil) then P^.GetData(Data^);
    Dispose(P, Done);
  end;
  ExecDialog := Result;
end;

function CreateFindDialog: PDialog;
var
  D: PDialog;
  Control: PView;
  R: TRect;
begin
  R.Assign(0, 0, 38, 12);
  D := New(PDialog, Init(R, 'Find'));
  with D^ do
  begin
    HelpCtx := hcSFind;
    Options := Options or ofCentered;
    R.Assign(3, 3, 32, 4);
    Control := New(PInputLine, Init(R, 80));
    Insert(Control);
    R.Assign(2, 2, 15, 3);
    Insert(New(PLabel, Init(R, '~T~ext to find', Control)));
    R.Assign(32, 3, 35, 4);
    Insert(New(PHistory, Init(R, PInputLine(Control), 10)));

    R.Assign(3, 5, 35, 7);
    Insert(New(PMyCheckBoxes, Init(R,
      NewSItem('~C~ase sensitive',
      NewSItem('~W~hole words only', nil)))));

    R.Assign(14, 9, 24, 11);
    Insert(New(PButton, Init(R, 'O~K~', cmOk, bfDefault)));
    Inc(R.A.X, 12); Inc(R.B.X, 12);
    Insert(New(PButton, Init(R, 'Cancel', cmCancel, bfNormal)));

    SelectNext(False);
  end;
  CreateFindDialog := D;
end;

function CreateReplaceDialog: PDialog;
var
  D: PDialog;
  Control: PView;
  R: TRect;
begin
  R.Assign(0, 0, 40, 16);
  D := New(PDialog, Init(R, 'Replace'));
  with D^ do
  begin
    HelpCtx := hcSReplace;
    Options := Options or ofCentered;

    R.Assign(3, 3, 34, 4);
    Control := New(PInputLine, Init(R, 80));
    Insert(Control);
    R.Assign(2, 2, 15, 3);
    Insert(New(PLabel, Init(R, '~T~ext to find', Control)));
    R.Assign(34, 3, 37, 4);
    Insert(New(PHistory, Init(R, PInputLine(Control), 10)));

    R.Assign(3, 6, 34, 7);
    Control := New(PInputLine, Init(R, 80));
    Insert(Control);
    R.Assign(2, 5, 12, 6);
    Insert(New(PLabel, Init(R, '~N~ew text', Control)));
    R.Assign(34, 6, 37, 7);
    Insert(New(PHistory, Init(R, PInputLine(Control), 11)));

    R.Assign(3, 8, 37, 12);
    Insert(New(PMyCheckBoxes, Init(R,
      NewSItem('~C~ase sensitive',
      NewSItem('~W~hole words only',
      NewSItem('~P~rompt on replace',
      NewSItem('~R~eplace all', nil)))))));

    R.Assign(17, 13, 27, 15);
    Insert(New(PButton, Init(R, 'O~K~', cmOk, bfDefault)));
    R.Assign(28, 13, 38, 15);
    Insert(New(PButton, Init(R, 'Cancel', cmCancel, bfNormal)));

    SelectNext(False);
  end;
  CreateReplaceDialog := D;
end;

function DoEditDialog(Dialog: Integer; Info: Pointer): Word; far;
var
  R: TRect;
  T: TPoint;
  D: PDialog;
begin
  case Dialog of
    edOutOfMemory:
      DoEditDialog := MessageBox('Not enough memory for this operation.',
        nil, mfError + mfOkButton, hcOKButton);
    edReadError:
      DoEditDialog := MessageBox('Error reading file %s.',
        @Info, mfError + mfOkButton, hcOKButton);
    edWriteError:
      DoEditDialog := MessageBox('Error writing file %s.',
        @Info, mfError + mfOkButton, hcOKButton);
    edCreateError:
      DoEditDialog := MessageBox('Error creating file %s.',
        @Info, mfError + mfOkButton, hcOKButton);
    edSaveModify:
      DoEditDialog := MessageBox('%s has been modified. Save?',
        @Info, mfInformation + mfYesNoCancel, hcYesNoCancel);
    edSaveUntitled:
      DoEditDialog := MessageBox('Save untitled file?',
        nil, mfInformation + mfYesNoCancel, hcYesNoCancel);
    edSaveAs:
      begin
        D := New(PFileDialog, Init('*.POV','Save file as', '~N~ame', fdOkButton, 100));
        D^.HelpCtx := hcFSaveAs;
        DoEditDialog := ExecDialog(D, Info);
      end;
    edFind:
      DoEditDialog := ExecDialog(CreateFindDialog, Info);
    edSearchFailed:
      DoEditDialog := MessageBox('Search string not found.',
        nil, mfError + mfOkButton, hcOKButton);
    edReplace:
      DoEditDialog := ExecDialog(CreateReplaceDialog, Info);
    edReplacePrompt:
      begin
        { Avoid placing the dialog on the same line as the cursor }
        R.Assign(0, 1, 40, 8);
        R.Move((Desktop^.Size.X - R.B.X) div 2, 0);
        Desktop^.MakeGlobal(R.B, T);
        Inc(T.Y);
        if TPoint(Info).Y <= T.Y then
          R.Move(0, Desktop^.Size.Y - R.B.Y - 2);
        DoEditDialog := MessageBoxRect(R, 'Replace this occurence?',
          nil, mfYesNoCancel + mfInformation, hcYesNoCancel);
      end;
  end;
end;

function OpenEditor(FileName: FNameStr; Visible: Boolean): PEditWindow;
var
  P: PView;
  R: TRect;
begin
  DeskTop^.GetExtent(R);
  P := Application^.ValidView(New(PEditWindow,
    Init(R, FileName, wnNoNumber)));
  if not Visible then P^. Hide;
  DeskTop^. Insert(P);
  OpenEditor := PEditWindow(P);
  P^.HelpCtx := hcEditor;
end;

function OpenLog(FileName: FNameStr; Visible: Boolean): PLogWindow;
var
  P: PView;
  R: TRect;
begin
  DeskTop^.GetExtent(R);
  P := Application^.ValidView(New(PLogWindow,
    Init(R, FileName, wnNoNumber)));
  if not Visible then P^. Hide;
  DeskTop^. Insert(P);
  OpenLog := PLogWindow(P);
  P^.HelpCtx := hcEditor;
end;

procedure LoadDeskTop;
  type
    Entry = record
              fn: FNameStr;
              R: TRect;
              Sel: boolean;
            end;
  var
    DT: File of Entry;
    E: Entry;
    W,SW: PEditWindow;
begin
  SW := nil;
  assign(DT,ShellPath+'\POVSHELL.DSK');
  reset(DT);
  if IOResult=0 then begin
    while not eof(DT) do begin
      read(DT,E);
      W := OpenEditor(E.fn,false);
      W^. ChangeBounds(E.R);
      if E.Sel then SW := W;
      W^.Show;
    end;
    close(DT);
  end;
  if SW<>nil then SW^.Select;
end;

procedure TEditorApp.InitScreen;
begin
  TApplication. InitScreen;
  if AppPalette <> apColor then UseMono := true
  else if UseMono then AppPalette := apBlackWhite;
end;

constructor TEditorApp. Init;
var
  H: Word;
  R: TRect;
  SR: SearchRec;
  NoCFG, DoAbout: boolean;
  i: integer;

procedure ReadCFG;
var f: text; line: string;
    c,i: integer; col: byte;
    token: string[8];
begin
  With Directories do begin
    DefaultPoVFilePath := 'C:\POV\SCENES';
    OutputFilePath := 'C:\POV';
    ExecPath := 'C:\POV\POVRAY.EXE';
  end;
  With EditorOptions do begin
    BIASOptions:=1+2+8;
    TabSizeString:=' 3';
  end;
  CFGPalette := CColor + CHelpColor;
  ResetRunOptions;
  for i:=0 to MaxApplic-1 do DisableCommands([cmApplic+i]);
  assign(f,ShellPath+'\POVSHELL.CFG');
  reset(f);
  NoCFG := false;
  if IOResult=0 then begin
    while not eof(f) do begin
      read(f,token);
      if token = 'DEFPATH=' then
        readln(f,Directories.DefaultPoVFilePath)
      else if token = 'OUTPATH=' then
        readln(f,Directories.OutputFilePath)
      else if token = 'EXEPATH=' then
        readln(f,Directories.ExecPath)
      else if token = 'EDFLAGS=' then begin
        readln(f,line);
        val(line,EditorOptions.BIASOptions,c);
      end else if token='TABSIZE=' then
        readln(f,EditorOptions.TabSizeString)
      else if token='COLOURS=' then begin
        read(f,col); CFGPalette[0]:=chr(col);
        for i:=1 to ord(CFGPalette[0]) do begin
          read(f,col);
          CFGPalette[i]:=chr(col);
        end;
        readln(f);
      end else if token='RUNFLAG=' then begin
        readln(f,line);
        val(line,RunOptions.TheRunOptions,c);
      end else if (copy(token,1,6)='APPLIC') and (copy(token,8,1)='=') then begin
        readln(f,line);
        val(token[7],i,c);
        if (i>0) and (i<=MaxApplic) then begin
          line := Trim(line);
          c := pos(',',line);
          if c=0 then c:=length(line)+1;
          if ParseApplic(i,copy(line,1,c-1),copy(line,c+1,length(line)-c))
          then EnableCommands([cmApplic+i-1]);
        end;
      end else readln(f,line);
    end;
    close(f);
  end else NoCFG := true;
  ConvertEditorOptions;
  CurPOVFileDir := Directories.DefaultPOVFilePath;
  Log := Nil;
  EdFileName := CurPOVFileDir + '\NONAME00.POV';
end;

begin
  ReadCFG;
  UseMono := False;
  for i:=1 to ParamCount do if ((ParamStr(i)='/b') or (ParamStr(i)='/B'))
    then UseMono := true;
  for i:=1 to ParamCount do if ((ParamStr(i)='/l') or (ParamStr(i)='/L'))
    then HeapSize := 16 * (1024 div 16);
  RegisterHelpFile;
  H := PtrRec(HeapEnd).Seg - PtrRec(HeapPtr).Seg;
  if H > HeapSize then BufHeapSize := H - HeapSize else BufHeapSize := 0;
  InitBuffers;
  TApplication. Init;
  if (EditorOptions.BIASOptions and 16)>0 then
    AppVideoMode := smFont8x8 + smCO80
  else
    AppVideoMode := smCO80;
  if (AppVideoMode <> StartupMode) then
    SetScreenMode(AppVideoMode);
  if UseMono then begin
    DisableCommands([cmColors]);
  end else begin
    GetPalette^ := CFGPalette;
  end;
  DisableCommands([cmSave, cmSaveAs, cmCut, cmCopy, cmPaste, cmClear,
    cmUndo, cmFind, cmReplace, cmSearchAgain, cmRun, cmTemplate]);
  EditorDialog := DoEditDialog;
  ClipWindow := OpenEditor('', False);
  if ClipWindow <> nil then
  begin
    Clipboard := ClipWindow^.Editor;
    Clipboard^.CanUndo := False;
  end;
  {*** Init Dialogs ***}
  ResetOutputOptions;
  ResetDisplayOptions;
  ResetTraceOptions;
  ResetMiscOptions;
  ResetLibs;
  ResetAniOptions;
  FindFirst(ShellPath+'\DEFAULT.DEF',AnyFile,SR);
  if DOSError=0 then DoRetrieveOptions(ShellPath+'\DEFAULT.DEF');
  DoAbout := true;
  for i:=1 to ParamCount do if (ParamStr(i)='/Q') or (ParamStr(i)='/q')
    then DoAbout := false;
  if DoAbout then About;
  if NoCFG then SetShellDirs;
  LoadDeskTop;
  if ParamCount > 0 then
    for i := 1 to ParamCount do
      if Copy(ParamStr(i),1,1) <> '/' then OpenEditor(ParamStr(i),true);
end;

function TEditorApp.GetPalette: PPalette;
const
  CNewColor = CColor + CHelpColor;
  CNewBlackWhite = CBlackWhite + CHelpBlackWhite;
  CNewMonochrome = CMonochrome + CHelpMonochrome;
  P: array[apColor..apMonochrome] of string[Length(CNewColor)] =
    (CNewColor, CNewBlackWhite, CNewMonochrome);
begin
  GetPalette := @P[AppPalette];
end;

procedure TEditorApp.GetEvent(var Event: TEvent);
var
  W: PWindow;
  HFile: PHelpFile;
  HelpStrm: PDosStream;
  Context: word;
  R: TRect;
  Sel: integer;
const
  HelpInUse: Boolean = False;
begin
  TApplication.GetEvent(Event);
  case Event.What of
    evCommand:
    begin
      Context := GetHelpCtx;
      DeskTop^.GetExtent(R); R.B.X := R.B.X - 6; R.B.Y := R.B.Y -4; Sel := 1;
      case Event.Command of
        cmIntroduction: begin
                          Context := hcNoContext;
                          RememberTopic(Context,0);
                        end;
        cmIndex:        begin
                          Context := hcIndex;
                          RememberTopic(Context,0);
                        end;
        cmHelpOnHelp:   begin
                          Context := hcHelpOnHelp;
                          RememberTopic(Context,0);
                        end;
        cmReference:    begin
                          Context := hcReference;
                          RememberTopic(Context,0);
                        end;
        cmLastTopic:    begin
                          if Remembered>0 then begin
                            Context := RememberList[Remembered].KR;
                            Sel := RememberList[Remembered].Sel;
                          end else begin
                            Context := hcNoContext;
                            RememberTopic(Context,0);
                          end;
                        end;
        cmHelp:         if not HelpInUse then RememberTopic(Context,0);
      end;
      if (Event.Command = cmIntroduction) or
         (Event.Command = cmIndex) or
         (Event.Command = cmHelpOnHelp) or
         (Event.Command = cmReference) or
         (Event.Command = cmLastTopic) then Event.Command := cmHelp;
      if (Event.Command = cmHelp) and not HelpInUse then
      begin
        HelpInUse := True;
        HelpStrm := New(PDosStream, Init(ShellPath+'\POVSHELL.HLP', stOpenRead));
        HFile := New(PHelpFile, Init(HelpStrm));
        if HelpStrm^.Status <> stOk then
        begin
          MessageBox('Could not open help file.', nil, mfError + mfOkButton, hcOKButton);
          Dispose(HFile, Done);
        end
        else
        begin
          W := New(PHelpWindow,Init(HFile, Context,Sel,R));
          if ValidView(W) <> nil then
          begin
            ExecView(W);
            Dispose(W, Done);
          end;
          ClearEvent(Event);
        end;
        HelpInUse := False;
      end;
    end;
    evMouseDown:
      if Event.Buttons <> 1 then Event.What := evNothing;
  end;
end;

destructor TEditorApp.Done;
begin
  TApplication.Done;
  DoneBuffers;
  ChDir(StartDirectory);
end;

procedure TEditorApp.HandleEvent(var Event: TEvent);
var DT: text;

procedure SetColors;
var
  D: PColorDialog;
begin
  D := New(PColorDialog, Init('',
    ColorGroup('Desktop',
      ColorItem('Color',             1, nil),
    ColorGroup('Menus',
      ColorItem('Normal',            2,
      ColorItem('Disabled',          3,
      ColorItem('Shortcut',          4,
      ColorItem('Selected',          5,
      ColorItem('Selected disabled', 6,
      ColorItem('Shortcut selected', 7, nil)))))),
    ColorGroup('Dialog boxes',
      ColorItem('Frame/background',  33,
      ColorItem('Frame icons',       34,
      ColorItem('Scroll bar page',   35,
      ColorItem('Scroll bar icons',  36,
      ColorItem('Static text',       37,
      ColorItem('Label normal',      38,
      ColorItem('Label selected',    39,
      ColorItem('Label shortcut',    40,
      ColorItem('Button normal',     41,
      ColorItem('Button default',    42,
      ColorItem('Button selected',   43,
      ColorItem('Button disabled',   44,
      ColorItem('Button shortcut',   45,
      ColorItem('Button shadow',     46,
      ColorItem('Cluster normal',    47,
      ColorItem('Cluster selected',  48,
      ColorItem('Cluster shortcut',  49,
      ColorItem('Input normal',      50,
      ColorItem('Input selected',    51,
      ColorItem('Input arrow',       52,
      ColorItem('History button',    53,
      ColorItem('History sides',     54,
      ColorItem('History bar page',  55,
      ColorItem('History bar icons', 56,
      ColorItem('List normal',       57,
      ColorItem('List focused',      58,
      ColorItem('List selected',     59,
      ColorItem('List divider',      60,
      ColorItem('Information pane',  61, nil))))))))))))))))))))))))))))),
    ColorGroup('Editor windows',
      ColorItem('Frame passive',      8,
      ColorItem('Frame active',       9,
      ColorItem('Frame icons',       10,
      ColorItem('Scroll bar page',   11,
      ColorItem('Scroll bar icons',  12,
      ColorItem('Text',              13, nil)))))),
    ColorGroup('Help windows',
      ColorItem('Frame',             65,
      ColorItem('Frame icons',       66,
      ColorItem('Scroll bar page',   67,
      ColorItem('Scroll bar icons',  68,
      ColorItem('Normal text',       69,
      ColorItem('Normal keyword',    70,
      ColorItem('Highlight Keyword', 71, nil))))))), nil)))))));

  D^.HelpCtx := hcTColors;
  if ValidView(D) <> nil then
  begin
    D^.SetData(Application^.GetPalette^);
    if Desktop^.ExecView(D) <> cmCancel then
    begin
      Application^.GetPalette^ := D^.Pal;
      DoneMemory;  { Dispose all group buffers }
      ReDraw;      { Redraw application with new palette }
    end;
    Dispose(D, Done);
  end;
end;

procedure FileOpen;
var
  FileName: FNameStr;
  D: PDialog;
  _N: NameStr; _E: ExtStr;
begin
  FileName := '*.pov';
  ChDir(CurPovFileDir);
  D := New(PFileDialog1, Init('*.POV', 'Open file','~N~ame', fdOpenButton, 100));
  D^.HelpCtx := HcFOpen;
  if ExecDialog(D, @FileName) <> cmCancel then begin
    FSplit(FileName,CurPovFileDir,_N,_E);
    Dec(CurPovFileDir[0]);
    OpenEditor(FileName, True);
  end;
end;

procedure FileNew;
begin
  OpenEditor('', True);
end;

procedure DoDosShell;
begin
  DoneSysError;
  DoneEvents;
  DoneVideo;
  DoneMemory;
  SetMemTop(Ptr(BufHeapPtr, 0));
  PrintStr(#13#10+'Type EXIT to return to POVShell...');
  SwapVectors;
  Exec(GetEnv('COMSPEC'), '');
  SwapVectors;
  SetMemTop(Ptr(BufHeapEnd, 0));
  InitMemory;
  InitVideo;
  InitEvents;
  InitSysError;
  Redraw;
end;

procedure ShowClip;
begin
  ClipWindow^.Select;
  ClipWindow^.Show;
end;

procedure Tile;
var
  R: TRect;
begin
  Desktop^.GetExtent(R);
  Desktop^.Tile(R);
end;

procedure Cascade;
var
  R: TRect;
begin
  Desktop^.GetExtent(R);
  Desktop^.Cascade(R);
end;

procedure RunPov;
type
  string2 = string[2];
var
  OptionString: ComStr; SR: SearchRec;
  f: file;
  DECo: word;
  DEString: string[3];
  Msg: string[80];
  D: PFileDialog;
  R: TRect;
  L: text;
  Year,Month,Day,DOW,Hour,Minute,Sec,Hdth: word;
  i: integer;
  COptions: ComStr;
function LZ(x: word): string2;
var temp: string2;
begin
  str(x,temp);
  if x<10 then temp:='0'+temp;
  LZ := temp;
end;
begin
  {*CLOSE OLD LOG-WINDOW*}
  if Log<>nil then Log^.Close;
  {*GET CURRENT POV-FILE-NAME*}
  Message(DeskTop^.Current, evBroadCast, cmGetFileName, nil);
  {*BUILD OPTION-STRING*}
  OptionString:=' +i'+TempPath+TempPOV;
  if OutputOptions.Format<>0 then begin
    if AskForOutputFile(EdFileName,ImageFileName)=cmCancel then exit;
    if CheckOutput(ImageFileName)=cmCancel then exit;
    if OutputOptions.Format=3 then begin
      FSplit(ImageFileName,_D,_N,_E); ImageFileName := _D+_N;
    end;
    OptionString := OptionString + ' +o'+ImageFileName;
  end else ImageFileName := '';
  OptionString := OptionString + ' ' + TempPath+TempDEF;
  {*SAVE TEMPORARY POV-FILE*}
  if Message(DeskTop^.Current, evBroadCast, cmTempSave, nil)=nil then Exit;
  DoSaveOptions(TempPath+TempDEF);
  FSplit(EdFileName,_D,_N,_E); Dec(_D[0]);
  ChDir(_D);
  {* EXECUTE POV *}
  if (RunOptions.TheRunOptions and 4) = 0 then
    ExecProgram(Directories.ExecPath,OptionString,(RunOptions.TheRunOptions and 1) > 0)
  else begin
    GetDate(Year,Month,Day,DOW);
    GetTime(Hour,Minute,Sec,Hdth);
    assign(L,TempPath+LogFile); rewrite(L);
    writeln(L,'Inputfile:   ',EdFileName);
    if OutputOptions.Format<>0 then writeln(L,'Outputfile:  ',ImageFileName)
    else writeln(L,'Outputfile:  none');
    writeln(L,'Start time:  ',Year,'-',LZ(Month),'-',LZ(Day),' ',
              LZ(Hour),':',LZ(Minute),':',LZ(Sec));
    writeln(L);
    close(L);
    ExecProgram(GetEnv('COMSPEC'), '/C '+
    Directories.ExecPath+' '+OptionString+
    ' >> '+TempPath+LogFile,(RunOptions.TheRunOptions and 1) > 0);
  end;
  if DOSError<>0 then begin str(DOSError:3,DEString);
    MessageBox('DOS-Error '+DEString+' occured on execute!'+#13+
               'Check Execution-path in SETUP|DIRECTORIES...!',
               nil,mfError+mfOKButton, hcOKButton);
  end else begin DECo:=DOSExitCode; str(DECo,DEString);
    case DECo of
      0: Msg := Directories.ExecPath+' completed successfully.';
      1: Msg := 'Error(s) reported by '+Directories.ExecPath+' !';
      2: Msg := 'Trace aborted.';
      else begin
        Msg := 'Unexpected error:'+#13+
               Directories.ExecPath+' terminated with ExitCode '+DEString+'!';
      end;
    end;
    if (((RunOptions.TheRunOptions and 2) > 0) or (DECo=1) or (DECo>2))
      and ((RunOptions.TheRunOptions and 4) = 0) then
      MessageBox(Msg,nil, mfInformation+mfOKButton, hcOKButton);
    if ((RunOptions.TheRunOptions and 4) >0) and ((DECo=0) or (DECo=2)) then begin
      Log := OpenLog(TempPath+logFile,false);
      DeskTop^.GetExtent(R);
      Inc(R.A.X,2); Dec(R.B.X,2); Inc(R.A.Y,2); Dec(R.B.Y,2);
      if Log<>nil then begin
        Log^.ChangeBounds(R);
        Log^.Show;
      end;
    end;
  end;
  assign(f,TempPath+TempPOV); Erase(f);
  assign(f,TempPath+TempDEF); Erase(f);
end;

procedure SaveDeskTop;
  type
    Entry = record
              fn: FNameStr;
              R: TRect;
              Sel: boolean;
            end;
  var
    DT: File of Entry;
    E: Entry;
  procedure writename(p: PEditWindow); far;
  begin
    if (Pointer(p) <> Pointer(DeskTop^.Last)) and (p <> ClipWindow) then begin
      E.fn := p^.Editor^.FileName;
      p^. GetBounds(E.R);
      E.Sel := p^. GetState(sfSelected);
      write(DT,E);
    end;
  end;
begin
  assign(DT,ShellPath+'\POVSHELL.DSK');
  rewrite(DT);
  DeskTop^. ForEach(@writename);
  close(DT);
end;

procedure SaveCFG;
var f: text;
    i: integer; si: string[1];
begin
  assign(f,ShellPath+'\POVSHELL.CFG');
  rewrite(f);
  writeln(f,'DEFPATH='+Trim(Directories.DefaultPoVFilePath));
  writeln(f,'OUTPATH='+Trim(Directories.OutputFilePath));
  writeln(f,'EXEPATH='+Trim(Directories.ExecPath));
  with EditorOptions do begin
    writeln(f,'EDFLAGS=',BIASOptions);
    writeln(f,'TABSIZE=',TabSize);
  end;
  if UseMono then begin
    write(f,'COLOURS=',Length(CFGPalette),' ');
    for i:=1 to Length(CFGPalette) do write(f,Ord(CFGPalette[i]),' ');
  end else begin
    write(f,'COLOURS=',Length(GetPalette^),' ');
    for i:=1 to Length(GetPalette^) do write(f,Ord(GetPalette^[i]),' ');
  end;
  writeln(f);
  writeln(f,'RUNFLAG=',RunOptions.TheRunOptions);
  for i:=1 to MaxApplic do begin
    str(i,si);
    writeln(f,'APPLIC',si,'=',Applic[i]^.Name^,',',
              ApplicCommand[i].Prog^,' ',ApplicCommand[i].Params^);
  end;
  close(f);
end;

procedure ListTemplates;
var
  R: TRect;
  V: PTPLDialog;
begin
  R.Assign(1,1,{34} 52,21);
  V := New(PTPLDialog,Init(R,' Select template '));
  V^.HelpCtx := hcTemplate;
  if DeskTop^.ExecView(V) = cmOK then begin
    V^.GetData(TPLTopic);
    Dispose(V, Done);
    if TPLTopic <> '*??????????*' then
      if Message(DeskTop^.Current, evBroadCast, cmInsertTemplate, nil)=nil then Exit;
  end else Dispose(V, Done);
end;

procedure DoUpdateScreenMode;
begin
  SetScreenMode(AppVideoMode);
end;

begin
  if (Event.What=evCommand) and (Event.Command=cmQuit) then begin
    If Log<>Nil then Log^.Close;
    SaveCFG;
    if (EditorOptions.BIASOptions and 8)>0 then SaveDeskTop
    else begin
      assign(DT,ShellPath+'\POVSHELL.DSK');
      erase(DT);
    end;
  end;
  TApplication.HandleEvent(Event);
  case Event.What of
    evBroadcast:
      case Event.Command of
        cmUpdateScreenMode: DoUpdateScreenMode;
        cmRedrawApp: ReDraw;
      end;
    evCommand:
      case Event.Command of
        cmOpen: FileOpen;
        cmNew: FileNew;
        cmDosShell: DoDosShell;
        cmShowClip: ShowClip;
        cmTile: Tile;
        cmCascade: Cascade;
        cmAbout: About;
        cmRun: RunPoV;
        cmTemplate: ListTemplates;
        cmOutputOptions: SetOutputOptions(0);
        cmDisplayOptions: SetDisplayOptions(0);
        cmTraceOptions: SetTraceOptions(0);
        cmLibs: SetLibs;
        cmMiscOptions: SetMiscOptions(1,0);
        cmRetrieveOptions: RetrieveOptions;
        cmSaveOptions: SaveOptions;
        cmSaveDefOptions: SaveDefOptions;
        cmShellDirs: SetShellDirs;
        cmEditor: begin SetEditor; DeskTop^. ReDraw; end;
        cmColors: SetColors;
        cmSetupRun: SetupRun;
        cmCreateBatch: CreateBatch;
        cmClockAnimation: ClockAnimation;
        cmSysInfo: ShowSysInfo;
        cmApplic..cmApplic+MaxApplic-1: ExecProgram(
                 ApplicCommand[Event.Command-cmApplic+1].Prog^,
                 ApplicCommand[Event.Command-cmApplic+1].Params^,
                 false);
        cmDefineApps: DefineApps;
        cmFOption: SetOutputOptions(0);    cmCOption: SetOutputOptions(1);
        cmBOption: SetOutputOptions(2);    cmVOption: SetMiscOptions(1,1);
        cmPOption: SetMiscOptions(1,2);    cmXOption: SetMiscOptions(1,3);
        cmKOption: SetMiscOptions(1,4);    cmSOption: SetMiscOptions(3,0);
        cmEOption: SetMiscOptions(5,0);    cmQOption: SetTraceOptions(0);
        cmAOption: SetTraceOptions(1);     cmJOption: SetTraceOptions(3);
        cmROption: SetTraceOptions(5);     cmMOption: SetTraceOptions(6);
        cmDOption: SetDisplayOptions(0);   cmWOption: SetDisplayOptions(2);
        cmHOption: SetDisplayOptions(2);   cmLOption: SetLibs;
      else
        Exit;
      end;
  else
    Exit;
  end;
  ClearEvent(Event);
end;

procedure TEditorApp. InitMenuBar;
var
  R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  MenuBar := New(PMenuBar, Init(R, NewMenu(
    NewSubMenu('~F~ile', hcFile, NewMenu(
      NewItem('~O~pen...', 'F3', kbF3, cmOpen, hcFOpen,
      NewItem('~N~ew', '', kbNoKey, cmNew, hcFNew,
      NewItem('~S~ave', 'F2', kbF2, cmSave, hcFSave,
      NewItem('S~a~ve as...', '', kbNoKey, cmSaveAs, hcFSaveAs,
      NewLine(
      NewItem('~D~OS shell', '', kbNoKey, cmDosShell, hcFDOSShell,
      NewItem('E~x~it', 'Alt-X', kbAltX, cmQuit, hcFExit,
      nil)))))))),
    NewSubMenu('~E~dit', hcEdit, NewMenu(
      NewItem('~U~ndo', '', kbNoKey, cmUndo, hcEUndo,
      NewLine(
      NewItem('Cu~t~', 'Shift-Del', kbShiftDel, cmCut, hcECut,
      NewItem('~C~opy', 'Ctrl-Ins', kbCtrlIns, cmCopy, hcECopy,
      NewItem('~P~aste', 'Shift-Ins', kbShiftIns, cmPaste, hcEPaste,
      NewItem('~S~how clipboard', '', kbNoKey, cmShowClip, hcEShowClip,
      NewLine(
      NewItem('~C~lear', 'Ctrl-Del', kbCtrlDel, cmClear, hcEClear,
      nil))))))))),
    NewSubMenu('~S~earch', hcSearch, NewMenu(
      NewItem('~F~ind...', '', kbNoKey, cmFind, hcSFind,
      NewItem('~R~eplace...', '', kbNoKey, cmReplace, hcSReplace,
      NewItem('~S~earch again', '', kbNoKey, cmSearchAgain, hcSAgain,
      nil)))),
    NewSubMenu('~W~indows', hcWindows, NewMenu(
      NewItem('~S~ize/move','Ctrl-F5', kbCtrlF5, cmResize, hcWSizeMove,
      NewItem('~Z~oom', 'F5', kbF5, cmZoom, hcWZoom,
      NewItem('~T~ile', '', kbNoKey, cmTile, hcWTile,
      NewItem('C~a~scade', '', kbNoKey, cmCascade, hcWCascade,
      NewItem('~N~ext', 'F6', kbF6, cmNext, hcWNext,
      NewItem('~P~revious', 'Shift-F6', kbShiftF6, cmPrev, hcWPrevious,
      NewItem('~C~lose', 'Alt-F3', kbAltF3, cmClose, hcWClose,
      nil)))))))),
    NewSubMenu('~O~ptions', hcOptions, NewMenu(
      NewItem('~O~utput...', '', kbNoKey, cmOutputOptions, hcOOutput,
      NewItem('~D~isplay...', '', kbNoKey, cmDisplayOptions, hcODisplay,
      NewItem('~T~race...', '', kbNoKey, cmTraceOptions, hcOTrace,
      NewItem('~L~ibrary-paths...', '', kbNoKey, cmLibs, hcOLibPaths,
      NewItem('~M~isc...', '', kbNoKey, cmMiscOptions, hcOMisc,
      NewLine(
      NewItem('~S~ave Options...', '', kbNoKey, cmSaveOptions, hcOSaveOptions,
      NewItem('S~a~ve Default Options','',kbNoKey, cmSaveDefOptions, hcOSaveDefOptions,
      NewItem('~R~etrieve Options...', '', kbNoKey, cmRetrieveOptions, hcORetrieveOptions,
      nil)))))))))),
    NewSubMenu('Se~t~up', hcSetup, NewMenu(
      NewItem('~D~irectories...','',kbNoKey, cmShellDirs, hcTDirectories,
      NewItem('~E~ditor...','',kbNoKey, cmEditor, hcTEditor,
      NewItem('~C~olors...','',kbNoKey, cmColors, hcTColors,
      NewItem('~R~un...','',kbNoKey, cmSetupRun, hcTRun,
      nil))))),
    NewItem('Te~m~plates', '', kbNoKey, cmTemplate, hcTemplate,
    NewSubMenu('~U~tils', hcUtils, NewMenu(
      NewItem('Create ~B~atch...','',kbNoKey, cmCreateBatch, hcUCreateBatch,
      NewItem('Clock ~A~nimation...','',kbNoKey, cmClockAnimation, hcUClockAnimation,
      NewLine(
      NewItem('~D~efine Apps...','',kbNoKey, cmDefineApps, hcUDefineApps,
      NewLine(
      Applic[1])))))),
    NewItem('~R~un', 'Ctrl-F9',kbCtrlF9, cmRun, hcRun,
    NewSubMenu('~H~elp', hcHelp, NewMenu(
      NewItem('~C~ontents','',kbNoKey,cmIntroduction, hcHIntroduction,
      NewItem('~I~ndex','Shift-F1',kbShiftF1,cmIndex, hcHIndex,
      NewItem('~H~elp on Help','',kbNoKey,cmHelpOnHelp, hcHHelpOnHelp,
      NewItem('~L~ast Topic','Alt-F1',kbAltF1,cmLastTopic, hcHLastTopic,
      NewLine(
      NewItem('~P~OVRay reference','Ctrl-F1',kbCtrlF1,cmReference,hcHReference,
      NewLine(
      NewItem('~A~bout', '', kbNoKey, cmAbout, hcHAbout,
      NewItem('~S~ystem Info', 'Alt-0', kbAlt0, cmSysInfo, hcHSysInfo,
      nil)))))))))),
    nil)))))))))))));
end;

procedure TEditorApp. InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  New(StatusLine, Init(R,
    NewStatusDef(0, $FFFF,
      NewStatusKey('~F1~ Help', kbF1, cmHelp,
      NewStatusKey('~F2~ Save', kbF2, cmSave,
      NewStatusKey('~F3~ Open', kbF3, cmOpen,
      NewStatusKey('', kbAltF3, cmClose,
      NewStatusKey('~F5~ Zoom', kbF5, cmZoom,
      NewStatusKey('~F6~ Next', kbF6, cmNext,
      NewStatusKey('~Ctrl-F9~ Run', kbCtrlF9, cmRun,
      NewStatusKey('~F10~ Menu', kbF10, cmMenu,
      NewStatusKey('', kbCtrlF5, cmResize,
      nil))))))))),
    nil)));
end;

procedure TEditorApp.OutOfMemory;
begin
  MessageBox('Not enough memory for this operation.',
    nil, mfError + mfOkButton, hcOKButton);
end;

begin
  PoVShellApp.Init;
  PoVShellApp.Run;
  PoVShellApp.Done;
end.
