
{*** system info tools for POVSHELL
     last modified: 15.Oct.1994, AP ***}

unit SysInfo;

interface
  procedure ShowSysInfo;

implementation

{$F-}
{$L prozpa}
{$L viospa}

uses
  Dos,Dialogs,Objects,Views,App,PovSHelp;

type
  ProName = string[20];                 { Array mit Prozessornamen }
  Vios = record     { beschreibt Video-Karte samt angeschl. Monitor }
           Karte,
           Monitor : byte;
         end;
  ViosPtr = ^Vios;                 { Pointer auf eine VIOS-Struktur }


const
  ProzName : array [0..8] of ProName =
                     ( 'Intel 8088',                          { Code 0 }
                       'Intel 8086',                          { Code 1 }
                       'NEC V20',                             { Code 2 }
                       'NEC V30',                             { Code 3 }
                       'Intel 80188',                         { Code 4 }
                       'Intel 80186',                         { Code 5 }
                       'Intel 80286',                         { Code 6 }
                       'Intel 80386',                         { Code 7 }
                       'Intel 80486' );                       { Code 8 }

  CoName : array [0..3] of ProName =
                     ( 'not installed',                     { Code 0 }
                       '8087',                                { Code 1 }
                       '80287',                               { Code 2 }
                       '80387/80487' );                       { Code 3 }

  NO_VIOS    = 0;                              { keine Video-Karte }
  VGA        = 1;                                      { VGA-Karte }
  EGA        = 2;                                      { EGA-Karte }
  MDA        = 3;                     { Monochrome Display Adapter }
  HGC        = 4;                         { Hercules Graphics Card }
  CGA        = 5;                         { Color Graphics Adapter }

  VideoName: array[NO_VIOS..CGA] of string[6] =
      ('none','(S)VGA','EGA','MDA','HGC','CGA');

  MULTIPLEX  = $2F;     { Interrupt-Nummer des Multiplex-Interrupt }
  NO_WIN     = $00;                          { Windows nicht aktiv }
  W_386_X    = $01;                      { Windows /386 V2.X luft }
  W_REAL     = $81;                  { Windows luft im Real-Modus }
  W_STANDARD = $82;              { Windows luft im Standard-Modus }
  W_ENHANCED = $83;           { Windows luft im Erweiterten-Modus }

var
  VidSys : array[1..2] of Vios;  { Array mit den beiden Video-Struk. }
  Regs: Registers;
  WindowsAktiv,                                      { Windows-Modus }
  HVer,                                   { Hauptversion von Windows }
  NVer         : integer;                 { Nebenversion von Windows }
  XMSHandler : Pointer;

function GetProz : integer; external;
function GetCo   : integer; external;
procedure GetVios( vp : ViosPtr ) ; external ;

function windows( var HVersion, NVersion : integer ) : integer;
  var
    regs : registers;                  { Register fr Interrupt-Aufruf }
    Erg  : integer;
  function int2fcall : integer;
  begin
    inline( $b8 / $00 / $16 /                      { mov   ax,1600h      }
            $cd / $2f /                            { int   2Fh           }
            $89 / $46 / $FE );                     { mov   [bp-2], ax    }
  end;
begin
  HVersion := 0;                        { Initialisiere Versionsnummer }
  NVersion := 0;
  erg := int2fcall;              { Installationstest Erweiterter-Modus }
  case ( lo(Erg) ) of
    $01,
    $FF:  begin
            HVersion := 2;                              { Hauptversion }
            NVersion := 0;                    { Nebenversion unbekannt }
            Windows := W_386_X;
          end;
    $00,
    $80:  begin
            regs.ax := $4680;  { Real- u. Standardmodus identifizieren }
            intr( MULTIPLEX, regs );
            if ( regs.al = $80 ) then
              Windows := NO_WIN                  { Windows luft nicht }
            else
              begin
                regs.ax := $1605;   { Installation DOS-Extender simul. }
                regs.bx := $0000;
                regs.si := $0000;
                regs.cx := $0000;
                regs.es := $0000;
                regs.ds := $0000;
                regs.dx := $0001;
                intr( MULTIPLEX, regs );
                if ( regs.cx = $0000 ) then
                  begin
                    regs.ax := $1606;
                    intr( MULTIPLEX, regs );
                    Windows := W_REAL;
                  end
                else
                  Windows := W_STANDARD;
              end;
          end;
    else
      begin
        HVersion := lo(Erg);                { Windows Version ausgeben }
        NVersion := hi(Erg);
        Windows := W_ENHANCED;          { Windows im Erweiterten-Modus }
      end;
  end;
end;

function GetFreeXMS: word; assembler;
asm
  mov ah,8;
  call es:XMSHandler;
  mov ax,dx;
end;

procedure ShowSysInfo;
var
  R: TRect;
  D: PDialog;
  s1,s2: string[3];
  s3: string[30];

begin
  R.Assign(1,1,50,15);
  D := New(PDialog,Init(R,' System Info '));
  R.Assign(3,2,48,3);
  D^.Insert(New(PStaticText,Init(R,'Processor    : '+ProzName[GetProz])));
  R.Assign(3,3,48,4);
  D^.Insert(New(PStaticText,Init(R,'Co-Processor : '+CoName[GetCo])));
  GetVios( @VidSys );
  R.Assign(3,4,48,5);
  D^.Insert(New(PStaticText,Init(R,'Primary Video: '+VideoName[VidSys[1].Karte])));
  Regs.AH := $30;
  Intr($21,Regs);
  str(Regs.AL,s1); str(Regs.AH,s2);
  R.Assign(3,5,48,6);
  D^.Insert(New(PStaticText,Init(R,'DOS-Version  : '+s1+'.'+s2)));
  WindowsAktiv := windows( HVer, NVer );
  str(HVer,s1); str(NVer,s2);
  case ( WindowsAktiv ) of
    NO_WIN:     s3 := 'Not running' ;
    W_REAL:     s3 := 'Running in Real Mode' ;
    W_STANDARD: s3 := 'Running in Standard Mode' ;
    W_386_X:    s3 := 'Windows/386 V 2.x running' ;
    W_ENHANCED: s3 := 'Windows '+s1+'.'+s2+' (Enhanced Mode)';
  end;
  R.Assign(3,6,48,7);
  D^.Insert(New(PStaticText,Init(R,'Windows:     : '+s3)));
  R.Assign(3,7,48,8);
  str(DiskFree(3),s3); if s3='-1' then s3 := 'not installed';
  D^.Insert(New(PStaticText,Init(R,'Harddisk C   : '+s3+' bytes free')));
  R.Assign(3,8,48,9);
  str(MemAvail,s3);
  D^.Insert(New(PStaticText,Init(R,'Program Heap : '+s3+' bytes free')));
  R.Assign(3,9,48,10);
  Regs.AX := $4300;
  s3 := 'not available';
  Intr($2F,Regs);
  if Regs.AL=$80 then begin
    Regs.AX := $4310; Intr($2F,Regs);
    XMSHandler := ptr(Regs.ES,Regs.BX);
    str(GetFreeXMS,s3);
  end;
  D^.Insert(New(PStaticText,Init(R,'Ext. Memory  : '+s3+' KB free')));
  R.Assign(18,11,32,13);
  D^. Insert(New(PButton, Init(R, ' ~O~K', cmOK, bfDefault)));

  D^.HelpCtx := hcHSysInfo;
  D^.Options := D^.Options or OfCentered;
  if DeskTop^.ExecView(D) = cmOK then;
  Dispose(D,Done);

end;

end.

