
{*** Template list unit for POVSHELL
     last modified: 12.Oct.1994, AP ***}

unit TPLList;

interface

uses crt, dos, objects, drivers, memory, views, dialogs,
     stddlg, msgbox, PovGlob;

type

  PTPLCollection = ^TTPLCollection;
  TTPLCollection = object(TStringCollection)
    constructor Init(ALimit, ADelta: Integer);
  end;

  PTPLList = ^TTPLList;
  TTPLList = object(TSortedListBox)
    constructor Init(var Bounds: TRect; ANumCols: Word;
      AScrollBar: PScrollBar);
    destructor Done; virtual;
    procedure FocusItem(Item: Integer); virtual;
    function DataSize: word; virtual;
    procedure GetData(var Rec); virtual;
    procedure SetData(var Rec); virtual;
    function GetText(Item: Integer; MaxLen: Integer): String; virtual;
    function GetKey(var S: String): Pointer; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
  end;

  PTPLDialog = ^TTPLDialog;
  TTPLDialog = object(TDialog)
    TPLCollection: PTPLCollection;
    TPLList: PTPLList;
    constructor Init(var Bounds: TRect; ATitle: TTitleStr);
    procedure GetData(var Rec); virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
  end;


implementation

constructor TTPLCollection.Init(ALimit, ADelta: Integer);
var
  P:  PString;
  SR: SearchRec;
  D: DirStr;
  E: ExtStr;
  TPL: Text;
  Line: String;
begin
  TStringCollection .Init(5,5);
  P := @P;
  Assign(TPL,ShellPath+'\POVSHELL.TPL');
  reset(TPL);
  if IOResult = 0 then begin
    While (not eof(TPL)) and (P <> nil) do begin
      readln(TPL,Line);
      if Line[1] = ':' then begin
          If Length(Line) > 13 then
            P := NewStr(Copy(Line,2,12))
          else
            P := NewStr(Copy(Line,2,Length(Line)-1));
          Insert(P);
      end;
    end;
    Close(TPL);
  end;
end;

constructor TTPLList.Init(var Bounds: TRect; ANumCols: Word;
                 AScrollBar: PScrollBar);
begin
  TSortedListBox.Init(Bounds, ANumCols, AScrollBar);
end;

function TTPLList.DataSize: word;
begin
  DataSize := 0;
end;

procedure TTPLList.GetData(var Rec);
begin
end;

procedure TTPLList.SetData(var Rec);
begin
end;

destructor TTPLList.Done;
begin
  if List <> nil then Dispose(List, Done);
  TListBox.Done;
end;

procedure TTPLList.FocusItem(Item: Integer);
begin
  TSortedListBox.FocusItem(Item);
  Message(Owner, evBroadcast, cmFileFocused, List^.At(Item));
end;

function TTPLList.GetText(Item: Integer; MaxLen: Integer): String;
begin
  GetText := TSortedListBox.GetText(Item,MaxLen);
end;

function TTPLList.GetKey(var S: String): Pointer;
begin
  GetKey := @S;
end;

procedure TTPLList.HandleEvent(var Event: TEvent);
begin
  if (Event.What = evMouseDown) and (Event.Double) then
  begin
    Event.What := evCommand;
    Event.Command := cmOK;
    PutEvent(Event);
    ClearEvent(Event);
  end
  else TSortedListBox.HandleEvent(Event);
end;

constructor TTPLDialog.Init(var Bounds: TRect; ATitle: TTitleStr);
const
  NoFiles: TPLString = '*??????????*';

var
  R: TRect;
  Control: PView;
  P: ^TPLString;

begin
  TDialog.Init(Bounds, ATitle);
  Options := Options or ofCentered;

  TPLCollection := New(PTPLCollection, Init(5,5));
  if TPLCollection^.Count = 0 then begin
    P := MemAlloc(SizeOf(P^));
    if P<>nil then begin
      P^ := NoFiles;
      TPLCollection^.Insert(P);
    end;
  end;

  R.Assign(2,15,{31} 49,16);
  Control := New(PScrollBar, Init(R));
  Insert(Control);

  R.Assign(2,2,{31} 49,15);
  TPLList := New(PTPLList, Init(R, {2} 3, PScrollBar(Control)));
  TPLList^.NewList(TPLCollection);
  Insert(TPLList);

  R.Assign(14,17,24,19);
  Insert(New(PButton, Init(R, 'O~K~', cmOK, bfDefault)));

  R.Assign(27,17,37,19);
  Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
  SelectNext(False);
end;

procedure TTPLDialog.GetData(var Rec);
begin
  move(TPLCollection^.At(TPLList^.Focused)^, Rec, SizeOf(TPLString))
end;

procedure TTPLDialog.HandleEvent(var Event: TEvent);
begin
  TDialog.HandleEvent(Event);
  if Event.What = evCommand then
    case Event.Command of
      cmOK, cmCancel:
        begin
          EndModal(Event.Command);
          ClearEvent(Event);
        end;
    end;
end;

end.
