{*** utility unit for POVSHELL
     last modified: 16.Oct.1994, AP ***}

unit Utils;

interface

uses Crt, Dos, Objects, Drivers, Memory, Views, Menus, Dialogs,
     StdDlg1, MsgBox1, App, Buffers, PovEdit, PovGlob, PovSHelp, PovDialg;

{$I commands.inc}

type

  TBatchDialog = object(TDialog)
    BatchOrAni: byte;
    BATFileText, POVFileText, OUTFileText: PStaticText;
    constructor Init(var Bounds: TRect; ATitle: TTitleStr);
    procedure HandleEvent(var Event: TEvent); virtual;
  end;
  PBatchDialog = ^TBatchDialog;

  TAniDialog = object(TBatchDialog)
    constructor Init(var Bounds: TRect; ATitle: TTitleStr);
  end;
  PAniDialog = ^TAniDialog;

  TOverAppendDialog = object(TDialog)
    constructor Init(FileName: PathStr);
  end;
  POverAppendDialog = ^TOverAppendDialog;

var
  BATFile, POVFile, OUTFile, DEFFile: FNameStr;
  SaveMode: (SMNew,SMAppend,SMCancel);

procedure CreateBatch;
procedure ClockAnimation;
procedure ResetAniOptions;

implementation

  constructor TOverAppendDialog.Init(FileName: PathStr);
  var R: TRect;
  begin
    R.Assign(1,1,52,8);
    TDialog.Init(R,'Information');
    Options := Options or OfCentered;
    HelpCtx := hcOverwriteAppend;
    R.Assign(2,2,48,4);
    Insert(New(PStaticText, Init(R, 'File '+FileName+' exists.')));
    R.Assign(3,4,16,6);
    Insert(New(PButton, Init(R, '~O~verwrite', cmYes, bfNormal)));
    R.Assign(19,4,32,6);
    Insert(New(PButton, Init(R, '~A~ppend', cmNo, bfNormal)));
    R.Assign(35,4,48,6);
    Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
  end;

  function FreeFile(Dir: DirStr; Root: NameStr; Ext: ExtStr): FNameStr;
  var
    i: word;
    s: string[3];
    _Root: string[5];
  begin
    i := 0;
    _Root := copy(Root+'________',1,5);
    repeat
      inc(i);
      str(i,s); s:=copy('00'+s,length(s),3);
    until (FSearch(_Root+s+Ext,Dir)='') or (i=999);
    if i=999 then s:='001';
    FreeFile := Dir+'\'+_Root+s+Ext;
  end;

  procedure CheckBAT(FileName: FNameStr);
  var
    D: POverAppendDialog;
    SR: SearchRec;
  begin
    FindFirst(FileName,AnyFile,SR);
    if DosError=0 then begin
      beep;
      D := New(POverAppendDialog,Init(FileName));
      case DeskTop^.ExecView(D) of
        cmYes: SaveMode := SMNew;
        cmNo: SaveMode := SMAppend;
        cmCancel: SaveMode := SMCancel;
      end;
      Dispose(D,Done);
    end else SaveMode := SMNew;
  end;

  procedure TBatchDialog.HandleEvent(var Event: TEvent);

    procedure ChangeBat;
    var
      Filename: PathStr;
      D: PFileDialog;
      CD: DirStr; CN: NameStr; CE: ExtStr;
    begin
      FSplit(BATFile,CD,CN,CE); Dec(CD[0]);
      ChDir(CD);
      Filename := CN+CE;
      D := New(PFileDialog, Init('*.BAT', 'Select Batch-File',
      '~N~ame', fdOpenButton, 0));
      D^.SetData(FileName);
      D^.HelpCtx := hcFSelectBox;
      SaveMode := SMNew;
      if DeskTop^.ExecView(D) <> cmCancel then begin
        D^.GetData(FileName);
        CheckBAT(FileName);
        if SaveMode <> SMCancel then begin
          BATFile := FileName;
          ReplaceStr(BATFileText^.Text,FileName);
          BATFileText^.Draw;
        end;
      end;
      Dispose(D,Done);
    end;

    procedure ChangePOV;
    var
      Filename: PathStr;
      SR: SearchRec;
      D: PFileDialog;
      temp: NameSTR;
    begin
      ChDir(CurPovFileDir);
      FileName := '*.POV';
      D := New(PFileDialog, Init('*.POV', 'Select POV-File',
      '~N~ame', fdOpenButton, 0));
      D^.SetData(FileName);
      D^.HelpCtx := hcFSelectBox;
      if DeskTop^.ExecView(D) <> cmCancel then begin
        D^.GetData(FileName);
        FindFirst(FileName,AnyFile,SR);
        if DosError<>0 then begin
          beep;
          MessageBox('File '+FileName+' not found!',nil,mfError+mfOKButton,hcOKButton);
        end else begin
          POVFile := FileName;
          ReplaceStr(POVFileText^.Text,FileName);
          POVFileText^.Draw;
          FSplit(FileName,_D,_N,_E); temp := _N;
          FSplit(BATFile,_D,_N,_E);
          BATFile := _D+temp+_E;
          ReplaceStr(BATFileText^.Text,BATFile);
          BATFileText^.Draw;
          if OUTFile<>'(none)' then begin
            FSplit(OUTFile,_D,_N,_E);
            if BatchOrAni = 1 then temp := copy(temp+'________',1,5)+'001';
            OUTFile := _D+temp+_E;
            ReplaceStr(OUTFileText^.Text,OUTFile);
            OUTFileText^.Draw;
          end;
        end;
      end;
      Dispose(D,Done);
    end;

    procedure ChangeOUT;
    begin
      if AskForOutputFile(OUTFile,OUTFile)<>cmCancel then begin
        if BatchOrAni = 1 then begin
          FSplit(OutFile,_D,_N,_E);
          _N := copy(_N+'________',1,5)+'001';
          OUTFile := _D + _N + _E;
        end;
        if CheckOutput(OUTFile)=cmCancel then exit;
        ReplaceStr(OUTFileText^.Text,OUTFile);
        OUTFileText^.Draw;
      end;
    end;

  begin
    if Event.What = evCommand then
      case Event.Command of
        cmChangeBatchBAT: ChangeBat;
        cmChangeBatchPOV: ChangePOV;
        cmChangeBatchOUT: ChangeOUT;
        cmBatchSaveOnly: EndModal(cmBatchSaveOnly);
        cmBatchSaveRun: EndModal(cmBatchSaveRun);
      end;
    TDialog.HandleEvent(Event);
  end;

  constructor TBatchDialog.Init(var Bounds: TRect; ATitle: TTitleStr);
  var
    R: TRect;
  begin
    TDialog.Init(Bounds,ATitle);
    Message(DeskTop^.Current, evBroadCast, cmGetFileName, nil);
    FSplit(EdFileName,_D,_N,_E);
    BATFile := ShellPath+'\'+_N+'.BAT';
    POVFile := EdFileName;
    if OutputOptions.Format = 0 then OUTFile := '(none)' else begin
      if Directories.OutputFilePath='' then OUTFile := _D
      else OUTFile := Directories.OutputFilePath + '\';
      OUTFile := OUTFile + _N + FormatExt[OutputOptions.Format];
    end;
    Options := Options or ofCentered;
    HelpCtx := hcUCreateBatch;
    R.Assign(3,2,16,4);
    Insert(New(PButton, Init(R, '~B~AT-File:', cmChangeBatchBat, bfNormal)));
    R.Assign(18,2,68,4);
    BATFileText:=New(PStaticText, Init(R,BATFile));
    Insert(BATFileText);
    R.Assign(3,4,16,6);
    Insert(New(PButton, Init(R, '~P~OV-File:', cmChangeBatchPOV, bfNormal)));
    R.Assign(18,4,68,6);
    POVFileText:=New(PStaticText, Init(R,POVFile));
    Insert(POVFileText);
    R.Assign(3,6,16,8);
    Insert(New(PButton, Init(R, ' ~O~utput: ', cmChangeBatchOUT, bfNormal)));
    if OUTFile='(none)' then DisableCommands([cmChangeBatchOUT])
    else EnableCommands([cmChangeBatchOUT]);
    R.Assign(18,6,68,8);
    OUTFileText:=New(PStaticText, Init(R,OUTFile));
    Insert(OUTFileText);
    R.Assign(10,9,23,11);
    Insert(New(PButton, Init(R, 'Sa~v~e Only', cmBatchSaveOnly, bfDefault)));
    R.Assign(28,9,42,11);
    Insert(New(PButton, Init(R, 'Save & ~R~un', cmBatchSaveRun, bfNormal)));
    R.Assign(47,9,57,11);
    Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
    SelectNext(True);
    SelectNext(True);
    BatchOrAni := 0;
  end;

  procedure SaveBAT;
  var
    BAT: Text;
    SR: SearchRec;
  begin
    FindFirst(POVFile,AnyFile,SR);
    if DosError<>0 then begin
      beep;
      MessageBox('File '+POVFile+' not found!',nil,mfError+mfOKButton,hcOKButton);
      SaveMode := SMCancel;
    end else begin
      CheckBAT(BATFile);
      if SaveMode<>SMCancel then begin
        if CheckOutput(OUTFile)<>cmCancel then begin
          if OutputOptions.Format=3 then begin
            FSplit(OUTFile,_D,_N,_E); OUTFile := _D+_N;
          end;
          DEFFile := FreeFile(ShellPath,'BATCH','.DEF');
          DoSaveOptions(DEFFile);
          assign(BAT,BATFile);
          if SaveMode=SMNew then rewrite(BAT) else append(BAT);
          if OUTFile<>'(none)' then
            writeln(BAT,Directories.ExecPath+
                      ' +i'+POVFile+
                      ' +o'+OUTFile+
                      ' '+DEFFile)
          else
            writeln(BAT,Directories.ExecPath+
                      ' +i'+POVFile+
                      ' '+DEFFile);
          close(BAT);
        end else SaveMode := SMCancel;
      end;
    end;
  end;

  procedure SaveAniBAT;

    function EndCond(x,x1,x2,st: real): boolean;
    begin
      EndCond := false;
      if (x1<=x2) and ((st<=0) or (x>x2)) then EndCond := true;
      if (x1>=x2) and ((st>=0) or (x<x2)) then EndCond := true;
    end;

  var
    BAT: Text;
    SR: SearchRec;
    temp: word;
    x,x1,x2,st: real;
    xs: string[11];
    i: integer;
    is: string[3];
  begin
    FindFirst(POVFile,AnyFile,SR);
    if DosError<>0 then begin
      beep;
      MessageBox('File '+POVFile+' not found!',nil,mfError+mfOKButton,hcOKButton);
      SaveMode := SMCancel;
    end else begin
      CheckBAT(BATFile);
      if SaveMode<>SMCancel then begin
        if CheckOutput(OUTFile)<>cmCancel then begin
          if OutputOptions.Format=3 then begin
            FSplit(OUTFile,_D,_N,_E); OUTFile := _D+_N;
          end;
          DEFFile := FreeFile(ShellPath,'ANIMA','.DEF');
          temp := MiscOptions.VPXKOptions;
          MiscOptions.VPXKOptions := MiscOptions.VPXKOptions and (1+2+4);
          DoSaveOptions(DEFFile); MiscOptions.VPXKOptions := temp;
          assign(BAT,BATFile);
          if SaveMode=SMNew then rewrite(BAT) else append(BAT);

          val(AniOptions.ClockFrom,x1,temp);
          val(AniOptions.ClockTo,x2,temp);
          val(AniOptions.ClockStep,st,temp);
          FSplit(OutFile,_D,_N,_E);
          _N := copy(_N+'________',1,5);

          x := x1; i := 1;
          repeat
            str(x:8:2,xs); xs := trim(xs);
            if OUTFile<>'(none)' then begin
              str(i,is); is:=copy('00'+is,length(is),3);
              writeln(BAT,Directories.ExecPath+
                        ' +i'+POVFile+
                        ' +o'+_D+_N+is+_E+
                        ' +k'+xs+
                        ' '+DEFFile)
            end else
              writeln(BAT,Directories.ExecPath+
                        ' +i'+POVFile+
                        ' +k'+xs+
                        ' '+DEFFile);
            x := x + st; inc(i);
          until EndCond(x,x1,x2,st) or (i=999);

          close(BAT);
        end else SaveMode := SMCancel;
      end;
    end;
  end;

  procedure CreateBatch;
  var
    D: PBatchDialog;
    R: TRect;
  begin
    R.Assign(1,1,70,13);
    D := New(PBatchDialog,Init(R,' Create Batch '));
    case DeskTop^. ExecView(D) of
      cmBatchSaveOnly: begin
        SaveBAT;
        if SaveMode=SMNew then
          MessageBox('Command written to Batch-File '+BATFile+'.',nil,
          mfOKButton+mfInformation,hcOKButton)
        else if SaveMode=SMAppend then
          MessageBox('Command appended to Batch-File '+BATFile+'.',nil,
          mfOKButton+mfInformation,hcOKButton);
      end;
      cmBatchSaveRun: begin
        SaveBAT;
        ExecProgram(BATFile,'',true);
      end
    end;
    Dispose(D,Done);
  end;

  constructor TAniDialog.Init(var Bounds: TRect; ATitle: TTitleStr);
  var
    R: TRect;
    ClockFrom,ClockTo,ClockStep: PRealInputLine;
  begin
    TDialog.Init(Bounds,ATitle);
    Message(DeskTop^.Current, evBroadCast, cmGetFileName, nil);
    FSplit(EdFileName,_D,_N,_E);
    BATFile := ShellPath+'\'+_N+'.BAT';
    POVFile := EdFileName;
    _N := copy(_N+'________',1,5)+'001';
    if OutputOptions.Format = 0 then OUTFile := '(none)' else begin
      if Directories.OutputFilePath='' then OUTFile := _D
      else OUTFile := Directories.OutputFilePath + '\';
      OUTFile := OUTFile + _N + FormatExt[OutputOptions.Format];
    end;
    Options := Options or ofCentered;
    HelpCtx := hcUClockAnimation;
    R.Assign(3,2,16,4);
    Insert(New(PButton, Init(R, '~B~AT-File:', cmChangeBatchBat, bfNormal)));
    R.Assign(18,2,68,4);
    BATFileText:=New(PStaticText, Init(R,BATFile));
    Insert(BATFileText);
    R.Assign(3,4,16,6);
    Insert(New(PButton, Init(R, '~P~OV-File:', cmChangeBatchPOV, bfNormal)));
    R.Assign(18,4,68,6);
    POVFileText:=New(PStaticText, Init(R,POVFile));
    Insert(POVFileText);
    R.Assign(3,6,16,8);
    Insert(New(PButton, Init(R, ' ~O~utput: ', cmChangeBatchOUT, bfNormal)));
    if OUTFile='(none)' then DisableCommands([cmChangeBatchOUT])
    else EnableCommands([cmChangeBatchOUT]);
    R.Assign(18,6,68,8);
    OUTFileText:=New(PStaticText, Init(R,OUTFile));
    Insert(OUTFileText);
    R.Assign(4,8,21,9);
    Insert(New(PStaticText, Init(R,'Clock Value:')));
    R.Assign(9,9,22,10);
    ClockFrom := New(PRealInputLine, Init(R,11,-9999999.99,99999999.99));
    Insert(ClockFrom);
    R.Assign(3,9,9,10);
    Insert(New(PLabel, Init(R,'~F~rom:',ClockFrom)));

    R.Assign(28,9,41,10);
    ClockTo := New(PRealInputLine, Init(R,11,-9999999.99,99999999.99));
    Insert(ClockTo);
    R.Assign(24,9,28,10);
    Insert(New(PLabel, Init(R,'~T~o:',ClockTo)));

    R.Assign(49,9,62,10);
    ClockStep := New(PRealInputLine, Init(R,11,-9999999.99,99999999.99));
    Insert(ClockStep);
    R.Assign(43,9,49,10);
    Insert(New(PLabel, Init(R,'~S~tep:',ClockStep)));

    R.Assign(10,12,23,14);
    Insert(New(PButton, Init(R, 'Sa~v~e Only', cmBatchSaveOnly, bfDefault)));
    R.Assign(28,12,42,14);
    Insert(New(PButton, Init(R, 'Save & ~R~un', cmBatchSaveRun, bfNormal)));
    R.Assign(47,12,57,14);
    Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
    SelectNext(True);
    SelectNext(True);
    SelectNext(True);
    SelectNext(True);
    SelectNext(True);
    BatchOrAni := 1;
  end;

  procedure ClockAnimation;
  var
    D: PAniDialog;
    R: TRect;
    St: word;
  begin
    R.Assign(1,1,70,16);
    D := New(PAniDialog,Init(R,' Clock Animation '));
    D^.SetData(AniOptions);
    St := DeskTop^. ExecView(D);
    if St<>cmCancel then D^.GetData(AniOptions);
    case St of
      cmBatchSaveOnly: begin
        SaveAniBAT;
        if SaveMode=SMNew then
          MessageBox('Command(s) written to Batch-File '+BATFile+'.',nil,
          mfOKButton+mfInformation,hcOKButton)
        else if SaveMode=SMAppend then
          MessageBox('Command(s) appended to Batch-File '+BATFile+'.',nil,
          mfOKButton+mfInformation,hcOKButton);
      end;
      cmBatchSaveRun: begin
        SaveAniBAT;
        ExecProgram(BATFile,'',true);
      end
    end;
    Dispose(D,Done);
  end;

  procedure ResetAniOptions;
  begin
    AniOptions.ClockFrom := '       0.00';
    AniOptions.ClockTo :=   '      10.00';
    AniOptions.ClockStep := '       1.00';
  end;

end.